> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.wynncraft.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.wynncraft.com/_mcp/server.

# Get class ability tree map

GET https://api.wynncraft.com/v3/ability/map/{tree}

This endpoint is cached for 1 hour in the SHARED cache source.   See [Caching](/welcome#caching).  This endpoint belongs to the SHARED rate-limit bucket. See [Throttling and Rate Limits](/welcome#throttling-and-rate-limits).

Ability and aspect responses use the [API Markup parser](/welcome#api-markup-parser).

Use these endpoints together to render a player ability tree like the in-game view:

* [GET /ability/tree/\{tree}](https://docs.wynncraft.com/modules/ability-aspect/get-ability-tree)
* [GET /ability/map/\{tree}](https://docs.wynncraft.com/modules/ability-aspect/get-ability-map)
* [GET /player/\{username}/characters/\{uuid}/abilities](https://docs.wynncraft.com/modules/player/get-player-character-abilities)

The map structure is shared with [GET /player/\{username}/characters/\{uuid}/abilities](https://docs.wynncraft.com/modules/player/get-player-character-abilities).

Reference: https://docs.wynncraft.com/modules/ability-aspect/get-ability-map

## Request

### Path parameters

- `tree` (enum, required)
  - Allowed values: `archer`, `warrior`, `assassin`, `mage`, `shaman`

## Response

### 200

Ability nodes grouped by page.

- `map from string to list of AbilityMapNode`

## Errors

### 400 Bad Request Error

Invalid class tree identifier.

- `error` (string, required)
- `detail` (string, required)
- `code` (integer, required)

## Types

### AbilityMapNode

- `type` (enum, required)
  - Allowed values: `ability`, `connector`
- `coordinates` (AbilityMapNodeCoordinates, required)
- `meta` (AbilityMapNodeMeta, required)
- `family` (list of string, required)

### AbilityMapNodeCoordinates

- `x` (integer, required)
- `y` (integer, required)

### AbilityMapNodeMeta

- `page` (integer, required)
- `icon` (AbilityMapNodeMetaIcon, optional)
- `id` (string, optional)

### AbilityMapNodeMetaIcon

### AbilityIcon

- `value` (AbilityIconValue, required)
- `format` (string, required)
- `name` (string, optional)

### AbilityIconValue

- `id` (string, required)
- `name` (string, required)
- `customModelData` (AbilityIconValueCustomModelData, required)

### AbilityIconValueCustomModelData

- `rangeDispatch` (list of integer, required)

## Examples

**Response**

```json
{
  "1": [
    {
      "type": "ability",
      "coordinates": {
        "x": 5,
        "y": 1
      },
      "meta": {
        "page": 1,
        "icon": {
          "value": {
            "id": "minecraft:potion",
            "name": "abilityTree.exampleStarter",
            "customModelData": {
              "rangeDispatch": [
                178
              ]
            }
          },
          "format": "attribute"
        },
        "id": "exampleStarter"
      },
      "family": [
        "exampleStarter"
      ]
    },
    {
      "type": "connector",
      "coordinates": {
        "x": 5,
        "y": 2
      },
      "meta": {
        "page": 1,
        "icon": "connector_up_down"
      },
      "family": [
        "exampleStarter",
        "exampleMiddle"
      ]
    },
    {
      "type": "ability",
      "coordinates": {
        "x": 5,
        "y": 3
      },
      "meta": {
        "page": 1,
        "icon": {
          "value": {
            "id": "minecraft:potion",
            "name": "abilityTree.exampleMiddle",
            "customModelData": {
              "rangeDispatch": [
                162
              ]
            }
          },
          "format": "attribute"
        },
        "id": "exampleMiddle"
      },
      "family": [
        "exampleMiddle"
      ]
    },
    {
      "type": "connector",
      "coordinates": {
        "x": 5,
        "y": 4
      },
      "meta": {
        "page": 1,
        "icon": "connector_up_down"
      },
      "family": [
        "exampleMiddle",
        "exampleFinisher"
      ]
    },
    {
      "type": "ability",
      "coordinates": {
        "x": 5,
        "y": 5
      },
      "meta": {
        "page": 1,
        "icon": {
          "value": {
            "id": "minecraft:potion",
            "name": "abilityTree.exampleFinisher",
            "customModelData": {
              "rangeDispatch": [
                166
              ]
            }
          },
          "format": "attribute"
        },
        "id": "exampleFinisher"
      },
      "family": [
        "exampleFinisher"
      ]
    }
  ]
}
```

**SDK Code**

```python Example ability map
import requests

url = "https://api.wynncraft.com/v3/ability/map/archer"

response = requests.get(url)

print(response.json())
```

```javascript Example ability map
const url = 'https://api.wynncraft.com/v3/ability/map/archer';
const options = {method: 'GET'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Example ability map
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.wynncraft.com/v3/ability/map/archer"

	req, _ := http.NewRequest("GET", url, nil)

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example ability map
require 'uri'
require 'net/http'

url = URI("https://api.wynncraft.com/v3/ability/map/archer")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)

response = http.request(request)
puts response.read_body
```

```java Example ability map
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.wynncraft.com/v3/ability/map/archer")
  .asString();
```

```php Example ability map
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.wynncraft.com/v3/ability/map/archer');

echo $response->getBody();
```

```csharp Example ability map
using RestSharp;

var client = new RestClient("https://api.wynncraft.com/v3/ability/map/archer");
var request = new RestRequest(Method.GET);
IRestResponse response = client.Execute(request);
```

```swift Example ability map
import Foundation

let request = NSMutableURLRequest(url: NSURL(string: "https://api.wynncraft.com/v3/ability/map/archer")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```